discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    # path('', include('todolist.urls')),
                                #app    #endpoints
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

from . import views

# The path() function can recieve four arguments
# We'll focus on the two arguments that are required, which are "route" and "view", and the third argument "name" which allows us to make global changes to the URL patterns of your project while only touching a single file
# Syntax
    # path(route, view, name)

app_name = 'todolist'
urlpatterns = [
    # /todolist route
    path('', views.index, name='index'),
    # /todolist/<todoitem_id> route
    # The <int:todoitem_id> allows for creating a dynamic link where the todoitem_id is provided
    path('<int:todoitem_id>/', views.todoitem, name='viewtodoitem'),
    # /todolist/register
    path('register', views.register, name="register"),
    # /todolist/change_password
    path('change_password', views.change_password, name="change_password"),
    # /todolist/login
    path('login', views.login_view, name="login"),
    # /todolist/logout
    path('logout', views.logout_view, name="logout"),
    path('add_task', views.add_task, name="add_task"),
    path('events/<int:event_id>/', views.events, name="events"),
    path('events/add_event', views.add_event, name="add_event")
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created')
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class Events(models.Model):
	event_name = models.CharField(max_length=50)
	description = models.CharField(max_length=500)
	status = models.CharField(max_length=50, default = "pending")
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

class RegisterForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	first_name = forms.CharField(label="First Name", max_length=20)
	last_name = forms.CharField(label="Last Name", max_length=20)
	email = forms.CharField(label="Email", max_length=20)
	password1 = forms.CharField(label="Password", max_length=20)
	password2 = forms.CharField(label="Confirm Password", max_length=20)

class AddEventForm(forms.Form):
	event_name = forms.CharField(label="Event Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

todolist/views.py
from django.http import HttpResponse

from django.shortcuts import render, redirect, get_object_or_404
# The from keyword allows importing of necessary Classes, methods and other items needed in our application from the "django.http" package while the "import" keyword defines what we are importing from the package
# from django.http import HttpResponse
# from django.template import loader
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from django.utils import timezone
from django.contrib.auth.hashers import make_password

# Local Imports
from .models import ToDoItem, Events
from django.contrib.auth.models import User
from .forms import LoginForm, AddTaskForm, RegisterForm,AddEventForm

def index(request):
    todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
    events_list = Events.objects.filter(user_id = request.user.id)

    context = {
        "todoitem_list": todoitem_list,
        "events_list": events_list,
        "user": request.user
    }
    return render(request, "todolist/index.html", context)

def todoitem(request, todoitem_id):
    # The model_to_dict method allows to convert models into dictionaries
    # The .get() Model method allows to retrieve a specific record using it's primary key (pk)
    todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
    # Instead of creating a context, we can pass the dictionary directly as the context of the view
    return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def events(request, event_id):
    event = get_object_or_404(Events, pk=event_id)
    return render(request, "todolist/events.html", model_to_dict(event))

def register(request):

    # users = User.objects.all()
    # is_user_registered = False
    # context = {
    #     "is_user_registered": is_user_registered
    # }

    # for indiv_user in users:
    #     if indiv_user.username == "johndoe":
    #         is_user_registered = True
    #         break

    # if is_user_registered == False:
    #     user = User()
    #     user.username = "johndoe"
    #     user.first_name = "John"
    #     user.last_name = "Doe"
    #     user.email = "john@mail.com"
    #     # The set_password method is used to ensure that the password is hashed using Django's authentication framework
    #     user.set_password("john1234")
    #     user.is_staff = False
    #     user.is_active = True
    #     user.save()
    #     context = {
    #         "first_name": user.first_name,
    #         "last_name": user.last_name
    #     }

    context = {}

    if request.method == "POST":
        
        form = RegisterForm(request.POST)

        if form.is_valid() == False:

            form = RegisterForm()

        else:

            username = form.cleaned_data['username']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']
            password1 = form.cleaned_data['password1']
            password2 = form.cleaned_data['password2']
            duplicate = User.objects.filter(email = email)

            if not duplicate and password1 == password2:
                User.objects.create(username = username, first_name = first_name, last_name = last_name, email = email, password = make_password(password1), is_staff=False, is_active=True)
                return redirect("todolist:login")

            else:

                context = { "error" : True }


    return render(request, "todolist/register.html", context)

def change_password(request):

    is_user_authenticated = False

    user = authenticate(username="johndoe", password="john1234")
    print(user)
    if user is not None:
        authenticated_user = User.objects.get(username='johndoe')
        authenticated_user.set_password("johndoe1")
        authenticated_user.save()
        is_user_authenticated = True
    context = {
        "is_user_authenticated": is_user_authenticated
    }

    return render(request, "todolist/change_password.html", context)

def login_view(request):

    context = {}

    if request.method == "POST":
        # Create a form instance and populate it with the data from the request
        form = LoginForm(request.POST)
        # Check whether the data is valid
        # Runs validation routines for all the form fields and returns true and palces the form's data in the cleaned data attribute
        if form.is_valid() ==False:
            # Return a blank login form
            form = LoginForm()
        else:
            # Receives the information from the form
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username = username, password = password)
            context = {
                "username" : username,
                "password" : password
            }
            if user is not None:
                login(request, user)
                return redirect ("todolist:index")
            else:
                context = {
                    "error" : True
                }
    return render(request, "todolist/login.html", context)

    # username = "johndoe"
    # password = "johndoe1"
    # user = authenticate(username=username, password=password)
    # context = {
    #     "is_user_authenticated": False
    # }
    # print(user)
    # if user is not None:
    #     # Saves the user’s ID in the session using Django's session framework
    #     login(request, user)
    #     return redirect("todolist:index")
    # else:
    #     return render(request, "todolist/login.html", context)

def logout_view(request):
    logout(request)
    return redirect("todolist:index")


def add_task(request):
    context = {}

    if request.method == "POST":
        form = AddTaskForm(request.POST)
        if form.is_valid() == False:
            form = AddTaskForm()

        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            duplicate = ToDoItem.objects.filter(task_name = task_name)

            if not duplicate:
                ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id = request.user.id)
                return redirect("todolist:index")

            else:

                context = { "error" : True }

    return render(request, "todolist/add_task.html", context)

def add_event(request):
    context = {}

    if request.method == "POST":
        form = AddEventForm(request.POST)
        if form.is_valid() == False:
            form = AddEventForm()

        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            duplicate = Events.objects.filter(event_name = event_name)

            if not duplicate:
                Events.objects.create(event_name=event_name, description=description, user_id = request.user.id)
                return redirect("todolist:index")

            else:

                context = { "error" : True }

    return render(request, "todolist/add_event.html", context)

todolist/templates/todolist/add_event.html
{% extends 'base.html' %}

	{% block title %}Add Event{% endblock %}

	{% block content %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center my-3">Add An Event</h1>
					{% if error == True %}
						<p class="text-danger">Duplicate task found</p>
					{% endif %}
					<form action="{% url 'todolist:add_event' %}" method="post">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="event_name">Event Name: </label>
						    <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Add Task">
						</div>

					</form>
				</div>
			</div>
		</div>
	{% endblock %}

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

	{% block title %}Add Task{% endblock %}

	{% block content %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center my-3">Add A Task</h1>
					{% if error == True %}
						<p class="text-danger">Duplicate task found</p>
					{% endif %}
					<form action="{% url 'todolist:add_task' %}" method="post">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="task_name">Task Name: </label>
						    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Add Task">
						</div>

					</form>
				</div>
			</div>
		</div>
	{% endblock %}

todolist/templates/todolist/change_password.html
{% if is_user_authenticated == False %}
	<h1>Invalid User Credentials</h1>
	<p>Check if the username and password is correct </p>
{% else %}
	<h1>User Password Successfully Updated</h1>
	<p>The password has been successfully updated</p>
{% endif %}

todolist/templates/todolist/events.html
<h1>{{ event_name }}</h1>
<h3>Description</h3>
<p>{{ description }}</p>
<h3>Status</h3>
<p>{{ status }}</p>
<a href="{% url 'todolist:index' %}">Back to index page</a>

todolist/templates/todolist/index.html
{% extends 'base.html' %}

<!-- Provides the title of the page to be provided in the template -->
<!-- This should correspond with the block name provided in the base.html -->
{% block title %} Home {% endblock %}

{% block content %}
    {% if todoitem_list and user.is_anonymous == False %}
        <h1 class="text-center my-3">Welcome {{ user.first_name }} {{user.last_name}}!</h1>
        <div class="containter">
            <div class = "row">
                <h3 class="text-center mb-3">My Task</h3>
                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                {% for todoitem in todoitem_list %}
                    <li><a href="{% url 'todolist:viewtodoitem' todoitem.id %}">{{ todoitem.task_name }}</a></li>
                {% endfor %}
                </ul>
        </div>
        </div>     

        <div class="containter">
            <div class = "row">
                <h3 class="text-center mb-3">My Events</h3>
                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                {% for event in events_list %}
                    <li><a href="{% url 'todolist:events' event.id %}">{{ event.event_name }}</a></li>
                {% endfor %}
                </ul>
        </div>
        </div>  

    {% elif user.is_anonymous == True %}

        <h1 class="text-center my-3">You are not authorized to access this page.</h1>
        <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
    {% else %}
        <h1 class="text-center my-3">Welcome {{ user.first_name }} {{user.last_name}}!</h1>
        <div class="containter text-center">
            <h3>My Tasks</h3>
            <p>No tasks have been created.</p>
        </div>
        <div class="containter text-center">
            <h3>My Events</h3>
            <p>No tasks have been created.</p>
        </div>
    {% endif %}
{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html' %}

{% block title %}Login{% endblock %}

{% block content %}
<div class="container">
	<div class="row">
		<div class="col-6 offset-3">
			<h1 class="text-center my-3">Login</h1>
			{% if error == True %}
				<p class="text-danger">Invalid user credentials, please check your username and password</p>
			{% endif %}
			<form action="{% url 'todolist:login' %}" method="post">
				<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
				<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
				{% csrf_token %}

				<div class="mb-3">
				    <label for="username">Username: </label>
				    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="password">Password: </label>
				    <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
				</div>

				<div class="text-center">
			    	<input class="btn btn-success" type="submit" value="Login">
				</div>

			</form>
		</div>
	</div>
</div>
{% endblock %}

todolist/templates/todolist/register.html
{% extends 'base.html' %}

{% block title %}Register{% endblock %}

{% block content %}
<div class="container">
	<div class="row">
		<div class="col-6 offset-3">
			<h1 class="text-center my-3">Register</h1>
			{% if error == True %}
				<p class="text-danger">Invalid user credentials, please check your username and password</p>
			{% endif %}
			<form action="{% url 'todolist:register' %}" method="post">
				<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
				<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
				{% csrf_token %}

				<div class="mb-3">
				    <label for="username">Username: </label>
				    <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="first_name">First Name: </label>
				    <input class="form-control" id="first_name" type="text" name="first_name" value="{{ first_name }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="last_name">Last Name: </label>
				    <input class="form-control" id="last_name" type="text" name="last_name" value="{{ last_name }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="email">Email: </label>
				    <input class="form-control" id="email" type="email" name="email" value="{{ email }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="password1">Password: </label>
				    <input class="form-control" id="password1" type="password" name="password1" value="{{ password1 }}" maxlength="20" required>
				</div>

				<div class="mb-3">
				    <label for="password2">Confirm Password: </label>
				    <input class="form-control" id="password2" type="password" name="password2" value="{{ password2 }}" maxlength="20" required>
				</div>

				<div class="text-center">
			    	<input class="btn btn-success" type="submit" value="Register">
				</div>

			</form>
		</div>
	</div>
</div>
{% endblock %}

todolist/templates/todolist/todoitem.html
<h1>{{ task_name }}</h1>
<h3>Description</h3>
<p>{{ description }}</p>
<h3>Status</h3>
<p>{{ status }}</p>
<a href="{% url 'todolist:index' %}">Back to index page</a>